package me.hammerle.snuviscript;

import me.hammerle.code.Script;
import me.hammerle.code.SnuviParser;
import me.hammerle.exceptions.SnuviException;
import me.hammerle.code.ISnuviScheduler;
import me.hammerle.exceptions.PreScriptException;

public class SnuviScript 
{
    public static void main(String[] args) 
    {
        SnuviParser parser = new SnuviParser((SnuviException ex) -> 
        {
            System.out.println("Exception " + ex);
            System.out.println(ex.getOriginalException());
            System.out.println(ex.getCode());
            if(ex instanceof PreScriptException)
            {
                System.out.println(((PreScriptException) ex).getException());
            }
            System.out.println(ex.getLine());
            System.out.println(ex.getScriptName());
        }, new ISnuviScheduler() 
        {
            @Override
            public int scheduleTask(Runnable r) 
            {
                System.out.println("Schedule");
                return 0;
            }

            @Override
            public int scheduleTask(Runnable r, long delay) 
            {
                System.out.println("Schedule");
                return 0;
            }
        });
        parser.registerConsumer("debug", (o, sc) -> System.out.println(o[0]));
        parser.registerFunction("ggv", (o, sc) -> o[0]);
        
        StringBuilder sb = new StringBuilder("wusi = 1;\n");
        int counter = 0;
        for(int i = 0; i < 1000; i++)
        {
            switch(counter)
            {
                case 0: sb.append("wusi += 1;\n"); break;
                case 1: sb.append("wusi *= 2;\n"); break;
                case 2: sb.append("wusi = wusi - 1;\n"); break;
                case 3: sb.append("wusi /= 2;\n"); break;
                case 4: sb.append("wusi += 1;\n"); break;
            }
            counter++;
            if(counter >= 5)
            {
                counter = 0;
            }
        }
        sb.append("debug(wusi);");
        
        /*String s = "i = 3;\n" +
"while(i < 10)\n" +
"{\n" +
"    j = 5;\n" +
"    debug(i);\n" +
"    while(j < 10)\n" +
"    {\n" +
"        debug(j);\n" +
"        j += 1;\n" +
"    }\n" +
"    i += 1;\n" +
"}";*/
        //System.out.println(s);
        //System.out.println("___________");
        parser.startScript(Script.class, "test", sb.toString(), true);
        //parser.startScript(Script.class, "test", s, true);
    }   
}
